## hubzero-submit-distributor 3.1.2-1+deb6

=== debian/changelog ===
hubzero-submit-distributor (3.1.2-1+deb6) unstable; urgency=low

  * Merger PBS SLURM remote execution scripts
  * Expand ~ if used in executable path
  * Modified scheme for generating user credential files.
    No longer need world readable copies of community credentials.
  * progressReport typo pagasus -> pegasus
  * Added runName to job monitor database
  * Eliminate RUNJOB
  * Introduce hierarchical probeSite structure
  * Eliminate --disableStateCheck

 -- Steven Clark <clarks@purdue.edu>  Tue, 13 Jun 2017 13:50:26 -0400

hubzero-submit-distributor (3.0.10-1) unstable; urgency=low

  * Fixed SLURM mpi batch script generation
  * Fixed resource limit filter when user specifies
    a whole node, n=0
  * Fixed Pegasus OS mapping from site catalog to dax file.
    Required lower case.
  * Added to factor to control refresh of identities on failure.
    If identities generation fails it will now be attempted again
    after a shorter interval.
    communityRefreshOnFailFactor and refreshOnFailFactor
  * Added ability to add arbitrary batch submission script commands
    through sites.dat.  Spurred on by need to specify an XSEDE reservation.
    submissionScriptCommands
  * Changed job kill command to be sh compatible.
       kill -s TERM `jobs -p`
    to
       pkill -TERM --parent $$
  * Check for existence of identity manager scripts.
  * Fix case where input file specified as absolute path and
    client/server do not share working directory.
  * Use more os information in Pegasus workflow dax builds.
    Include arch, osFlavor, osVersion, osRelease
  * Check for success of touch command.  It fails when filesystem is readonly.
  * Added configurable ssh options. Initial use is to set connection timeout
    and retry limit.

 -- Steven Clark <clarks@purdue.edu>  Mon, 11 Jul 2016 11:30:07 -0400

hubzero-submit-distributor (3.0.8-1) unstable; urgency=low

  * Another set of traps for os.getwd() failures
  * Added another trap for getcwd() failure.
  * Account for disabled sites when filtering member sites.
  * Added another trap for getcwd() failure.

 -- Steven Clark <clarks@purdue.edu>  Wed, 09 Mar 2016 15:24:15 -0500

hubzero-submit-distributor (3.0.2-1) unstable; urgency=low

  * add to sudoers config file

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Sun, 13 Sep 2015 15:34:12 -0400

hubzero-submit-distributor (3.0.1-1) unstable; urgency=low

  * Replaced string based data exchange API with JSON based exchange
  * Added identity manager service.  It supports community ssh, idividual
    ssh, community x509 proxy
  * Moved submission scripts from code to template files.  Using a common
    set of substitutions for all submission types.
  * Added job registration step preceeding job submission.
  * Extended resource limits to include core-minutes.
  * Added setting for maximum number of jobs at remote site.
  * Added calculation of user activity at remote sites.  The activity
    is compute as a decaying weighted average of the number of cores
    used for running jobs.
  * Users are allocation job slots with inverse proprotion to their
    activity.  This is a form of fair share.
  * Added centralized manager for daemon to maintain host and port location
    of the individual daemons.
  * Dropped RemoteBatchPBS8.  Resource allocation parameters are specified
    in sites.dat.  This allows the same batch submission template to used
    with multiple sets of resource alloation parameters.
  * Added ability to mix standard HTcondor and PBS jobs in Pegasus workflows.
    This requires Pegasus 4.5 or newer.
  * Added ability to report anonymous user names to remote submission sites.
    This was done to support XSEDE user data collection.
  * Report expandedSiteNames as a unique list
  * Trap some os.getcwd() exceptions.  Why these exceptions occur is a mystery
    but at least now they are trapped and the process does not crash.
  * Added BOINC job submission
  * Added BOINC job submission
  * Fixed cpu time accounting for parallel simulations
  * Simplyfied the MPI kill process for instant scripts

 -- Steven Clark <clarks@purdue.edu>  Mon, 07 Sep 2015 17:56:46 -0400

hubzero-submit-distributor (2.7.2.6-1) unstable; urgency=low

  * fix misspelled variable in Makefile (probably effected pegasus support)

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Sat, 05 Sep 2015 18:14:33 -0400

hubzero-submit-distributor (2.7.2.5-1) unstable; urgency=low

  * fix log directory and log file permissions
  * fix update-known-hosts to use `getent` if necessary to resolve hostname

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 26 Mar 2015 09:33:53 -0400

hubzero-submit-distributor (2.7.2.4-1) unstable; urgency=low

  * fix bad variable dereference in postinst update from last version

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 26 Feb 2015 14:23:11 -0500

hubzero-submit-distributor (2.7.2.3-1) unstable; urgency=low

  * fix bad variable name in postinst update from last version

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 26 Feb 2015 14:18:00 -0500

hubzero-submit-distributor (2.7.2.2-1) unstable; urgency=low

  * don't put empty log files in package, create them in configure step
  * fix missing classname in logger call

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 26 Feb 2015 11:55:40 -0500

hubzero-submit-distributor (2.7.2u1-1) unstable; urgency=low

  * specifically get fqdn for hostname

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Sat, 27 Sep 2014 15:23:54 -0400

hubzero-submit-distributor (2.7.2-1) unstable; urgency=low

  * Added shared file system option to job helper scripts. 
    Avoid removal of local shared file copies. 

 -- Nicholas J. Kisseberth <nkissebe@purdue.edu>  Thu, 25 Sep 2014 21:02:28 -0400

hubzero-submit-distributor (2.7.1-1) unstable; urgency=low

  * release 2.7.1, normalizing packaging, updating copyrights
  * PBS attribute specification
  * Added new function to facilitate builds site/tool interaction


=== debian/control ===
Source: hubzero-submit-distributor
Section: misc
Priority: optional
Maintainer: Nicholas J. Kisseberth <nkissebe@purdue.edu>
Build-Depends: debhelper (>= 8.0.0), python-support (>=0.8) , python-all  
Standards-Version: 3.8.4
X-Python-Version: >= 2.6
Homepage: http://hubzero.org

Package: hubzero-submit-distributor
Architecture: all
Depends: hubzero-use, hubzero-use-apps, bind9-host, openssh-client, sudo, adduser, python (>=2.6), ${misc:Depends}
Recommends: hubzero-submit-monitors, hubzero-submit-server
Description: HUBzero submit distributor
 HUBzero job submission distributor

## hubzero-submit-distributor 3.1.2-1+deb7

=== Makefile ===
# @package      hubzero-submit-distributor
# @file         Makefile
# @author       Nicholas J. Kisseberth <nkissebe@purdue.edu>
# @copyright    Copyright (c) 2010-2015 HUBzero Foundation, LLC.
# @license      http://opensource.org/licenses/MIT MIT
#
# Copyright (c) 2010-2015 HUBzero Foundation, LLC.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# HUBzero is a registered trademark of HUBzero Foundation, LLC.
#

ETC=$(DESTDIR)/etc
VARLOG=$(DESTDIR)/var/log
OPTSUBMIT=$(DESTDIR)/opt/submit

DISTRIBUTION := $(shell lsb_release -i -s)
MAJORVERSION := $(shell lsb_release -rs | cut -d . -f 1)

ifeq ($(DISTRIBUTION),Debian)
il=--install-layout=deb
endif

BATCHSCHEDULERS = condor ll lsf pbs sge slurm
BATCHSCRIPTS = cleanupjob.sh killbatchjob.sh movepegtmp2home.sh postprocessjob.sh \
               qsubfromcondor.sh receiveinput.sh stdtocondor.sh submitbatchjob.sh \
               transmitresults.sh
DISTRIBUTORSCRIPTS = update-known-hosts hubmail.py
DISTRIBUTORMAINS = distributor.py executePBS.py jobKill.py jobStatus.py venueProbeR.py
DISTRIBUTORDFTFILES = aggregators appaccess environmentwhitelist identities \
                      managers monitors sites tools tunnels
PEGASUSLOCALCONFIGS = pegasus_local.rc sites_local.xml

HUBHOSTNAME:=$(shell hostname --fqdn)

all:
	@true

install:
	# create-optsubmit
	install --mode 0755 -d $(OPTSUBMIT)
	# install-distributor-dft: 
	for dftFile in $(DISTRIBUTORDFTFILES) ; do \
		install --mode 0640 -D $${dftFile}.dft $(OPTSUBMIT)/$${dftFile}.dft ; \
	done
	[ -f $(ETC)/submit/distributor.conf ] || \
		install --mode 0644 -D distributor.conf_dft $(ETC)/submit/distributor.conf
	[ -f $(ETC)/submit/infos.conf ] || \
		install --mode 0644 -D infos.conf_dft $(ETC)/submit/infos.conf
	[ -f $(ETC)/submit/daemons.conf ] || \
		install --mode 0644 -D daemons.conf_dft $(ETC)/submit/daemons.conf
	# install-distributor-scripts
	install --mode 2750 -d $(OPTSUBMIT)/Scripts
	for batchScheduler in $(BATCHSCHEDULERS) ; do \
		install --mode 2750 -d $(OPTSUBMIT)/Scripts/$${batchScheduler}; \
		for batchScript in $(BATCHSCRIPTS) ; do \
			if [ -f Scripts/$${batchScheduler}/$${batchScript} ] ; then \
				install --mode 0755 -D Scripts/$${batchScheduler}/$${batchScript} $(OPTSUBMIT)/Scripts/$${batchScheduler}; \
			fi \
		done \
	done
	# install-distributor-submissionscripts
	cp -r SubmissionScripts $(OPTSUBMIT)
	find $(OPTSUBMIT)/SubmissionScripts -type f -exec chmod 0644 {} \;
	find $(OPTSUBMIT)/SubmissionScripts -type d -exec chmod 2755 {} \;
	# install-distributor-bin
	install --mode 2751 -d $(OPTSUBMIT)/bin
	for distributorScript in $(DISTRIBUTORSCRIPTS) ; do \
		install --mode 0755 -D bin/$${distributorScript} $(OPTSUBMIT)/bin/$${distributorScript}; \
	done
	# install-distributor-mains
	for distributorMain in $(DISTRIBUTORMAINS) ; do \
		install --mode 0755 -D $${distributorMain} $(OPTSUBMIT)/$${distributorMain}; \
	done
	(cd $(OPTSUBMIT); ln --force --symbolic distributor.py distributor)
	# install-distributor-keys
	install --mode 0751 -d $(OPTSUBMIT)/etc
	install --mode 0751 -d $(OPTSUBMIT)/.ssh
	# install-distributor-condor-scripts:
	install --mode 2751 -d $(OPTSUBMIT)/bin
	for batchScript in $(BATCHSCRIPTS) ; do \
		if [ -f Scripts/condor/$${batchScript} ] ; then \
			install --mode 0755 -D Scripts/condor/$${batchScript} $(OPTSUBMIT)/bin/$${batchScript}; \
			sed -e "s/@CONDORVERSION@/$(CONDORVERSION)/" \
				--in-place $(OPTSUBMIT)/bin/$${batchScript}; \
		fi \
	done
	# install-distributor-logs
	install --mode 0775 -d $(VARLOG)/submit
	install --mode 0755 -d $(VARLOG)/submit/distributor
	# install-pegasus-local: 
	for pegasusLocalConfig in $(PEGASUSLOCALCONFIGS) ; do \
           install --mode 0644 -D $${pegasusLocalConfig} $(OPTSUBMIT)/$${pegasusLocalConfig} ; \
	done
	# add sudoers file
	install --mode 0440 -D submit-distributor.sudoers $(ETC)/sudoers.d/submit-distributor
	python setup.py install $(COMPILE) --root $(DESTDIR)  $(il)

uninstall:
	@true

postinst:
	# install-user-gridman
	adduser --quiet --system --group --force-badname --home /var/gridman --shell /bin/bash --disabled-password --gecos Gridman gridman || true
	adduser --quiet gridman tunneler || true
	# install-distrubtor-dat
	for dftFile in $(DISTRIBUTORDFTFILES) ; do \
		[ -e $(OPTSUBMIT)/$${dftFile}.dat ] || install --mode 0644 -D $(OPTSUBMIT)/$${dftFile}.dft $(OPTSUBMIT)/$${dftFile}.dat; \
	done
	sed -e "s/@HUBHOSTNAME@/$(HUBHOSTNAME)/" --in-place $(OPTSUBMIT)/monitors.dat
	if [ -f /etc/submit/daemons.conf ] ; then sed -e "s/@HOSTNAME@/$(HUBHOSTNAME)/" --in-place /etc/submit/daemons.conf; fi
	# install-distributor-bin
	$(OPTSUBMIT)/bin/update-known-hosts $(HUBHOSTNAME)
	# install-distributor-keys
	if [ -f ${OPTSUBMIT}/.ssh/submit_rsa ] ; then \
            echo "submit RSA key already exists in ${OPTSUBMIT}/.ssh/submit_rsa"; \
        else \
            printf "y\n\n" | ssh-keygen -q -t rsa -f ${OPTSUBMIT}/.ssh/submit_rsa -N '' -C "submit@$(HUBHOSTNAME)"; \
        fi
	chown gridman $(OPTSUBMIT)/.ssh/submit_rsa $(OPTSUBMIT)/.ssh/submit_rsa.pub
	rm -f $(OPTSUBMIT)/etc/submit_rsa
	install -o gridman -g gridman --mode 0700 -d /var/gridman/.ssh
	cat $(OPTSUBMIT)/.ssh/submit_rsa.pub >> /var/gridman/.ssh/authorized_keys
	chown gridman:gridman /var/gridman/.ssh/authorized_keys
	chmod 0600 /var/gridman/.ssh/authorized_keys
	chown gridman:apps $(ETC)/submit/distributor.conf

	touch emptyFile
	[ -f $(VARLOG)/submit/distributor/distributor.log ] || \
		install --mode 0640 -D emptyFile $(VARLOG)/submit/distributor/distributor.log
	rm -f emptyFile

clean:
	find . -name '*.pyc' -delete
	rm -f build-stamp
	rm -f configure-stamp
	python setup.py clean
	rm -fr build

.PHONY: all install uninstall postinst clean

=== debian/changelog ===
hubzero-submit-distributor (3.1.2-1+deb7) unstable; urgency=low

  * Merger PBS SLURM remote execution scripts
  * Expand ~ if used in executable path
  * Modified scheme for generating user credential files.
    No longer need world readable copies of community credentials.
  * progressReport typo pagasus -> pegasus
  * Added runName to job monitor database
  * Eliminate RUNJOB
  * Introduce hierarchical probeSite structure
  * Eliminate --disableStateCheck

 -- Steven Clark <clarks@purdue.edu>  Tue, 13 Jun 2017 13:50:26 -0400

## hubzero-submit-distributor 3.1.2-1+deb8

=== debian/changelog ===
hubzero-submit-distributor (3.1.2-1+deb8) unstable; urgency=low

  * Merger PBS SLURM remote execution scripts
  * Expand ~ if used in executable path
  * Modified scheme for generating user credential files.
    No longer need world readable copies of community credentials.
  * progressReport typo pagasus -> pegasus
  * Added runName to job monitor database
  * Eliminate RUNJOB
  * Introduce hierarchical probeSite structure
  * Eliminate --disableStateCheck

 -- Steven Clark <clarks@purdue.edu>  Tue, 13 Jun 2017 13:50:26 -0400

## hubzero-submit-distributor 3.1.3-1+deb6

=== debian/changelog ===
hubzero-submit-distributor (3.1.3-1+deb6) unstable; urgency=low

  * Added files necessary for HTCondor submission to SLURM resources

 -- Steven Clark <clarks@purdue.edu>  Wed, 27 Sep 2017 09:58:07 -0400

hubzero-submit-distributor (3.1.2-1) unstable; urgency=low

  * Merger PBS SLURM remote execution scripts
  * Expand ~ if used in executable path
  * Modified scheme for generating user credential files.
    No longer need world readable copies of community credentials.
  * progressReport typo pagasus -> pegasus
  * Added runName to job monitor database
  * Eliminate RUNJOB
  * Introduce hierarchical probeSite structure
  * Eliminate --disableStateCheck

 -- Steven Clark <clarks@purdue.edu>  Tue, 13 Jun 2017 13:50:26 -0400

## hubzero-submit-distributor 3.1.3-1+deb7

=== debian/changelog ===
hubzero-submit-distributor (3.1.3-1+deb7) unstable; urgency=low

  * Added files necessary for HTCondor submission to SLURM resources

 -- Steven Clark <clarks@purdue.edu>  Wed, 27 Sep 2017 09:58:07 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Nicholas J. Kisseberth <nkissebe@purdue.edu>
-Build-Depends: debhelper (>= 8.0.0), python-support (>=0.8) , python-all  
+Build-Depends: debhelper (>= 8.0.0), python-support (>=0.8)  , python-all 
 Standards-Version: 3.8.4
 X-Python-Version: >= 2.6
 Homepage: http://hubzero.org

## hubzero-submit-distributor 3.1.3-1+deb8

=== Makefile ===
--- 
+++ 
@@ -40,10 +40,10 @@
 
 BATCHSCHEDULERS = condor ll lsf pbs sge slurm
 BATCHSCRIPTS = cleanupjob.sh killbatchjob.sh movepegtmp2home.sh postprocessjob.sh \
-               qsubfromcondor.sh receiveinput.sh stdtocondor.sh submitbatchjob.sh \
+               receiveinput.sh stdtocondor.sh submitbatchjob.sh submitfromcondor.sh \
                transmitresults.sh
 DISTRIBUTORSCRIPTS = update-known-hosts hubmail.py
-DISTRIBUTORMAINS = distributor.py executePBS.py jobKill.py jobStatus.py venueProbeR.py
+DISTRIBUTORMAINS = distributor.py executeRemoteBatch.py jobKill.py jobStatus.py venueProbeR.py
 DISTRIBUTORDFTFILES = aggregators appaccess environmentwhitelist identities \
                       managers monitors sites tools tunnels
 PEGASUSLOCALCONFIGS = pegasus_local.rc sites_local.xml

=== debian/changelog ===
hubzero-submit-distributor (3.1.3-1+deb8) unstable; urgency=low

  * Added files necessary for HTCondor submission to SLURM resources

 -- Steven Clark <clarks@purdue.edu>  Wed, 27 Sep 2017 09:58:07 -0400

## hubzero-submit-distributor 3.2.8-1+deb8

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
 # @package      hubzero-submit-distributor
 # @file         Makefile
 # @author       Nicholas J. Kisseberth <nkissebe@purdue.edu>
-# @copyright    Copyright (c) 2010-2015 HUBzero Foundation, LLC.
+# @copyright    Copyright (c) 2010-2018 HUBzero Foundation, LLC.
 # @license      http://opensource.org/licenses/MIT MIT
 #
-# Copyright (c) 2010-2015 HUBzero Foundation, LLC.
+# Copyright (c) 2010-2018 HUBzero Foundation, LLC.
 #
 # Permission is hereby granted, free of charge, to any person obtaining a copy
 # of this software and associated documentation files (the "Software"), to deal
@@ -38,10 +38,12 @@
 il=--install-layout=deb
 endif
 
-BATCHSCHEDULERS = condor ll lsf pbs sge slurm
+BATCHSCHEDULERS = boinc condor ll lsf pbs sge slurm
 BATCHSCRIPTS = cleanupjob.sh killbatchjob.sh movepegtmp2home.sh postprocessjob.sh \
                receiveinput.sh stdtocondor.sh submitbatchjob.sh submitfromcondor.sh \
-               transmitresults.sh
+               transmitresults.sh \
+               abortBatch.py createBatch.py fetchBatchOutput.py retireBatch.py \
+               submitBatchJob.py submitBatchJobs.py uploadFile.py uploadFiles.py
 DISTRIBUTORSCRIPTS = update-known-hosts hubmail.py
 DISTRIBUTORMAINS = distributor.py executeRemoteBatch.py jobKill.py jobStatus.py venueProbeR.py
 DISTRIBUTORDFTFILES = aggregators appaccess environmentwhitelist identities \

=== debian/changelog ===
hubzero-submit-distributor (3.2.8-1+deb8) unstable; urgency=low

     - Improve reporting of what is executed in joblog:event.
     - Revamped how redundant submission operates.
       It is permissible to submit redundant jobs when
       executables are staged.  Multiple venues can be
       specified on the command line.
     - Improved extraction of jobId for SLURM.
     - Fixed BOINC job wrapper script to turn off executable
       bit set on stdout/stderr files generated on
       Windows volunteer hosts.
     - Fix problem caused by attempting redundant simulation
       with pre-existing runName directory.
     - Fix problem caused by attempting redundant simulation
       with pre-existing runName directory.
     - Allow progress type submit reporting for
       non parametric runs.
     - Provide support for parametric substitution in
       environment variables.
     - Updated BOINC scripts error processing
     - Allow parameter sweep variables to be
       used in conjunction with environment variables.
     - Allow environment variables values to resolve
       to files and directories.
     - Look for file names in command arguments
       of the form input=file.
     - Moved RemoteJobMonitor.py, RemoteTunnelMonitor.py, and
       TunnelsInfo.py from common package.
     - Added glob style definition of *.dat Info files.
     - Define environment varible white list specification
       by groups
     - Transfer $SESSION variable to remote jobs
     - Parameteric specification of --env variables.
     - Added BOINC batch submission scripts.
     - Added BOINC workflow type.  Generated by parametric
       sweep submitting multiple jobs as a batch to
       BOINC.
     - Revamped BOINC job submission to utilize provided
       submit_rpc.  Eliminates required direct to BOINC
       server for job submission.  All HUB tools use a
       single BOINC application.  The BOINC application
       utilizes Docker containers running in a VirtualBox
       host.
     - Introduced two new Info types: toolFilesInfo and
       dockerImageInfo
     - Removed job submission type - runjob.  It was based
       on HTCondor-G.

 -- Steven Clark <clarks@purdue.edu>  Thu, 12 Apr 2018 16:16:35 -0400

hubzero-submit-distributor (3.1.3-1) unstable; urgency=low

  * Added files necessary for HTCondor submission to SLURM resources

 -- Steven Clark <clarks@purdue.edu>  Wed, 27 Sep 2017 09:58:07 -0400

=== debian/rules ===
#!/usr/bin/make -f
#
# @package      hubzero-submit-distributor
# @file         rules
# @author       Nicholas J. Kisseberth <nkissebe@purdue.edu>
# @copyright    Copyright (c) 2010-2015 HUBzero Foundation, LLC.
# @license      http://opensource.org/licenses/MIT MIT
#
# Copyright (c) 2010-2015 HUBzero Foundation, LLC.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# HUBzero is a registered trademark of HUBzero Foundation, LLC.
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

$(info ########## Goals: $(MAKECMDGOALS) ##########)

CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export CFLAGS
export CPPFLAGS
export CXXFLAGS
export LDFLAGS

DEB_MAJOR:=$(shell lsb_release -r -s | cut -d . -f 1)

configure:
	@echo "########## configure ##########"
	dh_testdir
	>$@

build: configure
	@echo "########## build ##########"
	dh_testdir
	$(MAKE)
	#>$@

clean:
	@echo "########## clean ##########"
	dh_testdir
	dh_testroot
	rm -fr build configure
	$(MAKE) clean
	dh_clean

install: build
	@echo "########## install ##########"
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/hubzero-submit-distributor COMPILE=--no-compile install

binary-indep: install
	@echo "########## binary-indep ##########"
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installexamples -i
	dh_install -i
	dh_installlogrotate -i
	dh_installinit -i
	dh_installman -i
	dh_python2 -i
	dh_link -i
	dh_strip -i
	dh_lintian -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: install
	@echo "########## binary-arch ##########"
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_install -a
	dh_installlogrotate -a
	dh_installinit -a
	dh_installman -a
	dh_link -a
	dh_strip -a
	dh_lintian -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep 
#binary: binary-arch
	@echo "########## binary ##########"

.PHONY: clean binary-indep binary-arch binary install

## hubzero-submit-distributor 3.2.9-1+deb7

=== debian/changelog ===
hubzero-submit-distributor (3.2.9-1+deb7) unstable; urgency=low

     - Report file tailing when using progress type submit.
     - Added missing toolfiles.dft file.
     - Moved default location of community SSH key from /opt/submit/etc to /opt/submit/.ssh

 -- Steven Clark <clarks@purdue.edu>  Wed, 13 Jun 2018 16:40:48 -0400

hubzero-submit-distributor (3.2.8-1) unstable; urgency=low

     - Improve reporting of what is executed in joblog:event.
     - Revamped how redundant submission operates.
       It is permissible to submit redundant jobs when
       executables are staged.  Multiple venues can be
       specified on the command line.
     - Improved extraction of jobId for SLURM.
     - Fixed BOINC job wrapper script to turn off executable
       bit set on stdout/stderr files generated on
       Windows volunteer hosts.
     - Fix problem caused by attempting redundant simulation
       with pre-existing runName directory.
     - Fix problem caused by attempting redundant simulation
       with pre-existing runName directory.
     - Allow progress type submit reporting for
       non parametric runs.
     - Provide support for parametric substitution in
       environment variables.
     - Updated BOINC scripts error processing
     - Allow parameter sweep variables to be
       used in conjunction with environment variables.
     - Allow environment variables values to resolve
       to files and directories.
     - Look for file names in command arguments
       of the form input=file.
     - Moved RemoteJobMonitor.py, RemoteTunnelMonitor.py, and
       TunnelsInfo.py from common package.
     - Added glob style definition of *.dat Info files.
     - Define environment varible white list specification
       by groups
     - Transfer $SESSION variable to remote jobs
     - Parameteric specification of --env variables.
     - Added BOINC batch submission scripts.
     - Added BOINC workflow type.  Generated by parametric
       sweep submitting multiple jobs as a batch to
       BOINC.
     - Revamped BOINC job submission to utilize provided
       submit_rpc.  Eliminates required direct to BOINC
       server for job submission.  All HUB tools use a
       single BOINC application.  The BOINC application
       utilizes Docker containers running in a VirtualBox
       host.
     - Introduced two new Info types: toolFilesInfo and
       dockerImageInfo
     - Removed job submission type - runjob.  It was based
       on HTCondor-G.

 -- Steven Clark <clarks@purdue.edu>  Thu, 12 Apr 2018 16:16:35 -0400

## hubzero-submit-distributor 3.2.9-1+deb8

=== Makefile ===
--- 
+++ 
@@ -47,7 +47,7 @@
 DISTRIBUTORSCRIPTS = update-known-hosts hubmail.py
 DISTRIBUTORMAINS = distributor.py executeRemoteBatch.py jobKill.py jobStatus.py venueProbeR.py
 DISTRIBUTORDFTFILES = aggregators appaccess environmentwhitelist identities \
-                      managers monitors sites tools tunnels
+                      managers monitors sites tools toolfiles tunnels
 PEGASUSLOCALCONFIGS = pegasus_local.rc sites_local.xml
 
 HUBHOSTNAME:=$(shell hostname --fqdn)
@@ -93,7 +93,6 @@
 	done
 	(cd $(OPTSUBMIT); ln --force --symbolic distributor.py distributor)
 	# install-distributor-keys
-	install --mode 0751 -d $(OPTSUBMIT)/etc
 	install --mode 0751 -d $(OPTSUBMIT)/.ssh
 	# install-distributor-condor-scripts:
 	install --mode 2751 -d $(OPTSUBMIT)/bin

=== debian/changelog ===
hubzero-submit-distributor (3.2.9-1+deb8) unstable; urgency=low

     - Report file tailing when using progress type submit.
     - Added missing toolfiles.dft file.
     - Moved default location of community SSH key from /opt/submit/etc to /opt/submit/.ssh

 -- Steven Clark <clarks@purdue.edu>  Wed, 13 Jun 2018 16:40:48 -0400

## hubzero-submit-distributor 3.4.2-1+deb8

=== Makefile ===
--- 
+++ 
@@ -45,7 +45,7 @@
                abortBatch.py createBatch.py fetchBatchOutput.py retireBatch.py \
                submitBatchJob.py submitBatchJobs.py uploadFile.py uploadFiles.py
 DISTRIBUTORSCRIPTS = update-known-hosts hubmail.py
-DISTRIBUTORMAINS = distributor.py executeRemoteBatch.py jobKill.py jobStatus.py venueProbeR.py
+DISTRIBUTORMAINS = distributor.py executeRemoteBatch.py jobKill.py jobStatus.py venueProbeR.py harvester.py
 DISTRIBUTORDFTFILES = aggregators appaccess environmentwhitelist identities \
                       managers monitors sites tools toolfiles tunnels
 PEGASUSLOCALCONFIGS = pegasus_local.rc sites_local.xml

=== debian/changelog ===
hubzero-submit-distributor (3.4.2-1+deb8) unstable; urgency=low

     - Update to version 3.4.2
     - Fix bug related to file tailing and job harvesting.
     - Added missing harvester top level script
     - Update to version 3.4.1
     - Improved loading of configuration files with better
       handling of error conditions.
     - Added --disableJobMonitoring.  This is available only
       for BOINC submission.  Rather than monitor job progress
       in the distributor process on the submit server updates
       are posted through the shared file system.  The objective
       is to greatly reduce the memory footprint of the monitoring
       process thus allowing many more simultaneous submissions.
     - Removed remaining vestiges of HUBGRIDJOB
     - Treat existing but empty BOINC result file as an error.
     - Modified quota checking when job is being run by ionhelper.  Quota of
       actual user is now checked.
     - Added --requestCache option for submit to directly query cache
       for result.
     - Record origin of Rappture driver file (human,specbot,etc.).
     - Fixed syntax error in job status (--status) reporting.
     - Fixed parametric sweep job status reporting.
     - Increased default memory requirement ofr BOINC jobs.  Hope to avoid
       client starting more jobs than can fit in host memory.
     - Centralized cleanup of various files created to support runs.
     - Release version 3.3.1.

 -- Steven Clark <clarks@purdue.edu>  Fri, 05 Jul 2019 16:24:22 -0400

hubzero-submit-distributor (3.2.9-1) unstable; urgency=low

     - Report file tailing when using progress type submit.
     - Added missing toolfiles.dft file.
     - Moved default location of community SSH key from /opt/submit/etc to /opt/submit/.ssh

 -- Steven Clark <clarks@purdue.edu>  Wed, 13 Jun 2018 16:40:48 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Nicholas J. Kisseberth <nkissebe@purdue.edu>
-Build-Depends: debhelper (>= 8.0.0), python-support (>=0.8)  , python-all 
+Build-Depends: debhelper (>= 8.0.0), python-support (>=0.8)   , dh-python
 Standards-Version: 3.8.4
 X-Python-Version: >= 2.6
 Homepage: http://hubzero.org

## hubzero-submit-distributor 3.4.3-2+deb9

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,9 @@
 # @package      hubzero-submit-distributor
 # @file         Makefile
-# @author       Nicholas J. Kisseberth <nkissebe@purdue.edu>
-# @copyright    Copyright (c) 2010-2018 HUBzero Foundation, LLC.
+# @copyright    Copyright (c) 2010-2020 The Regents of the University of California.
 # @license      http://opensource.org/licenses/MIT MIT
 #
-# Copyright (c) 2010-2018 HUBzero Foundation, LLC.
+# Copyright (c) 2010-2020 The Regents of the University of California.
 #
 # Permission is hereby granted, free of charge, to any person obtaining a copy
 # of this software and associated documentation files (the "Software"), to deal
@@ -24,7 +23,7 @@
 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 # THE SOFTWARE.
 #
-# HUBzero is a registered trademark of HUBzero Foundation, LLC.
+# HUBzero is a registered trademark of The Regents of the University of California.
 #
 
 ETC=$(DESTDIR)/etc

=== debian/changelog ===
hubzero-submit-distributor (3.4.3-2+deb9) unstable; urgency=low

  * add Debian 9 support

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Thu, 20 Aug 2020 16:20:56 -0700

hubzero-submit-distributor (3.4.3-1) unstable; urgency=low

     - update copyright/trademark ownership
     - update email address references
     - remove per file @author references
     - update copyright years
     - Improved treatment of command arguments containing spaces.
     - Added remote logging of job submission to executeRemoteBatch.
     - Added some error logging to JobHarvester.  Avoid crashing in some
       cases where data is incomplete.
     - Avoid crash when tail message is missing from remote submission.
     - Detect and report missing mail server in hubmail application.
     - Update to version 3.4.3

 -- Steven Clark <smclark@ucsd.edu>  Fri, 01 May 2020 17:42:49 -0700

hubzero-submit-distributor (3.4.2-1) unstable; urgency=low

     - Update to version 3.4.2
     - Fix bug related to file tailing and job harvesting.
     - Added missing harvester top level script
     - Update to version 3.4.1
     - Improved loading of configuration files with better
       handling of error conditions.
     - Added --disableJobMonitoring.  This is available only
       for BOINC submission.  Rather than monitor job progress
       in the distributor process on the submit server updates
       are posted through the shared file system.  The objective
       is to greatly reduce the memory footprint of the monitoring
       process thus allowing many more simultaneous submissions.
     - Removed remaining vestiges of HUBGRIDJOB
     - Treat existing but empty BOINC result file as an error.
     - Modified quota checking when job is being run by ionhelper.  Quota of
       actual user is now checked.
     - Added --requestCache option for submit to directly query cache
       for result.
     - Record origin of Rappture driver file (human,specbot,etc.).
     - Fixed syntax error in job status (--status) reporting.
     - Fixed parametric sweep job status reporting.
     - Increased default memory requirement ofr BOINC jobs.  Hope to avoid
       client starting more jobs than can fit in host memory.
     - Centralized cleanup of various files created to support runs.
     - Release version 3.3.1.

 -- Steven Clark <smclark@ucsd.edu>  Fri, 05 Jul 2019 16:24:22 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: hubzero-submit-distributor
 Section: misc
 Priority: optional
-Maintainer: Nicholas J. Kisseberth <nkissebe@purdue.edu>
-Build-Depends: debhelper (>= 8.0.0), python-support (>=0.8)   , dh-python
+Maintainer: Nicholas J. Kisseberth <nkisseberth@ucsd.edu>
+Build-Depends: debhelper (>= 8.0.0)    , dh-python 
 Standards-Version: 3.8.4
 X-Python-Version: >= 2.6
 Homepage: http://hubzero.org

## hubzero-submit-distributor 3.6.3-1+deb7

=== Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 il=--install-layout=deb
 endif
 
-BATCHSCHEDULERS = boinc condor ll lsf pbs sge slurm
+BATCHSCHEDULERS = boinc condor ll lsf pbs script sge slurm
 BATCHSCRIPTS = cleanupjob.sh killbatchjob.sh movepegtmp2home.sh postprocessjob.sh \
                receiveinput.sh stdtocondor.sh submitbatchjob.sh submitfromcondor.sh \
                transmitresults.sh \
@@ -47,7 +47,9 @@
 DISTRIBUTORMAINS = distributor.py executeRemoteBatch.py jobKill.py jobStatus.py venueProbeR.py harvester.py
 DISTRIBUTORDFTFILES = aggregators appaccess environmentwhitelist identities \
                       managers monitors sites tools toolfiles tunnels
-PEGASUSLOCALCONFIGS = pegasus_local.rc sites_local.xml
+PEGASUSTEMPLATEDIRECTORY = pegasusTemplates.d
+PEGASUSLOCALVERSIONS = 4.8.1 4.9.2 5.0.0 5.0.1
+PEGASUSLOCALCONFIGS = pegasus_local.rc sites_local.xml sites_local.yml
 
 HUBHOSTNAME:=$(shell hostname --fqdn)
 
@@ -77,6 +79,8 @@
 			fi \
 		done \
 	done
+	cp -rp Scripts/tapis $(OPTSUBMIT)/Scripts
+	find $(OPTSUBMIT)/Scripts/tapis -type d -exec chmod 2750 {} \;
 	# install-distributor-submissionscripts
 	cp -r SubmissionScripts $(OPTSUBMIT)
 	find $(OPTSUBMIT)/SubmissionScripts -type f -exec chmod 0644 {} \;
@@ -106,12 +110,19 @@
 	install --mode 0775 -d $(VARLOG)/submit
 	install --mode 0755 -d $(VARLOG)/submit/distributor
 	# install-pegasus-local: 
-	for pegasusLocalConfig in $(PEGASUSLOCALCONFIGS) ; do \
-           install --mode 0644 -D $${pegasusLocalConfig} $(OPTSUBMIT)/$${pegasusLocalConfig} ; \
+	install --mode 0755 -d $(OPTSUBMIT)/$(PEGASUSTEMPLATEDIRECTORY)
+	for pegasusLocalVersion in $(PEGASUSLOCALVERSIONS) ; do \
+		install --mode 0755 -d $(OPTSUBMIT)/$(PEGASUSTEMPLATEDIRECTORY)/pegasus-$${pegasusLocalVersion} ; \
+		for pegasusLocalConfig in $(PEGASUSLOCALCONFIGS) ; do \
+			if [ -f $(PEGASUSTEMPLATEDIRECTORY)/pegasus-$${pegasusLocalVersion}/$${pegasusLocalConfig} ] ; then \
+				install --mode 0644 -D $(PEGASUSTEMPLATEDIRECTORY)/pegasus-$${pegasusLocalVersion}/$${pegasusLocalConfig} $(OPTSUBMIT)/$(PEGASUSTEMPLATEDIRECTORY)/pegasus-$${pegasusLocalVersion}/$${pegasusLocalConfig} ; \
+			fi \
+		done \
 	done
 	# add sudoers file
 	install --mode 0440 -D submit-distributor.sudoers $(ETC)/sudoers.d/submit-distributor
-	python setup.py install $(COMPILE) --root $(DESTDIR)  $(il)
+	python2 setup.py install $(COMPILE) --root $(DESTDIR)  $(il)
+	python3 setup.py install $(COMPILE) --root $(DESTDIR)  $(il)
 
 uninstall:
 	@true

=== debian/changelog ===
hubzero-submit-distributor (3.6.3-1+deb7) unstable; urgency=low

    Allow for the possibility of relative path specification when file systems are not shared

 -- Steven Clark <smclark@ucsd.edu>  Tue, 16 May 2023 15:28:03 -0700

hubzero-submit-distributor (3.6.2-1) unstable; urgency=low

    - Added comparison operator functions to replace __cmp__ no longer available in Python3

 -- Steven Clark <smclark@ucsd.edu>  Fri, 04 Nov 2022 00:12:50 -0700

hubzero-submit-distributor (3.6.0-5) unstable; urgency=low

     - install python2 version of libraries as well

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Thu, 06 Jan 2022 10:37:21 -0800

hubzero-submit-distributor (3.6.0-4) unstable; urgency=low

     - rpm dependency fix for python36-GitPython and java-11-openjdk-headless

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 05 Jan 2022 21:09:36 -0800

hubzero-submit-distributor (3.6.0-3) unstable; urgency=low

     - rpm dependency fix for pyyaml

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 05 Jan 2022 16:06:14 -0800

hubzero-submit-distributor (3.6.0-2) unstable; urgency=low

     - Fixed Pegasus version directory
     - update packaging to python3
     - Moved TAPIS interface scripts from monitors to distributor repository
     - Update to version 3.6.0
     - Upgrade to Python3
     - Added support for multiple configurable Pegasus versions.
     - Added support for Pegasus/HTCondor workflow submission of
       script (no queue) jobs to clusters.
     - Created configurable directory for Pegasus related
       template files.  Different templates are used for each
       Pegasus version.
     - Added pre/post manager commands to Pegasus workflows.
     - Replaced ${HOME}/bin/time with /bin/time in submission
       scripts.
     - Added work around for missing /usr/bin/time at some
       OSG sites.

 -- Steven Clark <smclark@ucsd.edu>  Wed, 05 Jan 2022 16:02:20 -0800

hubzero-submit-distributor (3.5.1-1) unstable; urgency=low

     - Keep track of the exit status of each individual transaction for web service job
     - Added support for pre/post manage commands to Pegasus workflow.
     - Dropped support for gsissh.
     - Limit use of update-known-hosts to user gridman.
     - Added identity type for individual SSH keys.  Used by shared user
       accounts on the submit host.
     - Use template file to specify where monitoring web service is running.
     - Use configuration file to specify where backend compute web services
       are running.

 -- Steven Clark <smclark@ucsd.edu>  Mon, 13 Sep 2021 09:43:11 -0700

hubzero-submit-distributor (3.5.0-4) unstable; urgency=low

    - Added rule needed for community secret

 -- Steven Clark <smclark@ucsd.edu>  Mon, 12 Jul 2021 11:00:36 -0700

hubzero-submit-distributor (3.5.0-3) unstable; urgency=low

    - Mark config files as config files

 -- Steven Clark <smclark@ucsd.edu>  Fri, 09 Jul 2021 16:34:21 -0700

hubzero-submit-distributor (3.5.0-2) unstable; urgency=low

    - Add in users primary or default group

 -- Steven Clark <smclark@ucsd.edu>  Fri, 09 Jul 2021 15:50:43 -0700

hubzero-submit-distributor (3.5.0-1) unstable; urgency=low

    - Separated Local/Remote log file creation from script creation.
     - Added finer grained recording of when actions take place to
       better understand bottlenecks in webservice jobs.
     - Moved log service from LOCAL6 to LOCAL3.  Ideally this would be
       a configuration option.
     - Fixed testing of group privledge when submit is run under influence
       of sudo.  Tests need to be made against the actual user not the
       sudo user.
     - Added support to identity manager for oauthtokens.  Use case is
       the TAPIS service.
     - Added support for TAPIS job submission as a RemoteBATCH classification.
     - Added asynchronous job submission to support webservice.
     - Added support for Pegasus version 5+.  Configuration files
       went from xml to yml.
     - Added manager option to script based jobs.
     - Numerous additions made to Remote/Job monitor in support of
       webservice job submission.
     - Update to version 3.5.0
     - update for hosts with multiple aliases

 -- Steven Clark <smclark@ucsd.edu>  Thu, 08 Jul 2021 10:26:14 -0700

hubzero-submit-distributor (3.4.4-1) unstable; urgency=low

  * Pegasus 5 update
  * Scale core per node to user request.  Assumes node sharing is possible.
  * Added manager for serial computational mode execution.
  * Added parallel computational mode to SLURM batch submission.
  * California copyright update.

 -- Steven Clark <smclark@ucsd.edu>  Mon, 03 May 2021 12:18:21 -0700

hubzero-submit-distributor (3.4.3-2) unstable; urgency=low

  * add Debian 9 support

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Thu, 20 Aug 2020 16:20:56 -0700

=== debian/rules ===
--- 
+++ 
@@ -2,11 +2,10 @@
 #
 # @package      hubzero-submit-distributor
 # @file         rules
-# @author       Nicholas J. Kisseberth <nkissebe@purdue.edu>
-# @copyright    Copyright (c) 2010-2015 HUBzero Foundation, LLC.
+# @copyright    Copyright (c) 2010-2020 The Regents of the University of California.
 # @license      http://opensource.org/licenses/MIT MIT
 #
-# Copyright (c) 2010-2015 HUBzero Foundation, LLC.
+# Copyright (c) 2010-2020 The Regents of the University of California.
 #
 # Permission is hereby granted, free of charge, to any person obtaining a copy
 # of this software and associated documentation files (the "Software"), to deal
@@ -26,7 +25,7 @@
 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 # THE SOFTWARE.
 #
-# HUBzero is a registered trademark of HUBzero Foundation, LLC.
+# HUBzero is a registered trademark of The Regents of the University of California.
 #
 
 # Uncomment this to turn on verbose mode.

## hubzero-submit-distributor 3.6.3-1+deb10

=== debian/changelog ===
hubzero-submit-distributor (3.6.3-1+deb10) unstable; urgency=low

    Allow for the possibility of relative path specification when file systems are not shared

 -- Steven Clark <smclark@ucsd.edu>  Tue, 16 May 2023 15:28:03 -0700

## hubzero-submit-distributor 3.7.0-1+deb7

=== debian/changelog ===
hubzero-submit-distributor (3.7.0-1+deb7) unstable; urgency=low

     - Changed mount point detection to recognize shared
       mount.projfs file systems. This includes /data/projects.
       This avoids extra file transfer of potentially large files.

 -- Steven Clark <smclark@ucsd.edu>  Thu, 18 May 2023 10:48:31 -0700

hubzero-submit-distributor (3.6.3-1) unstable; urgency=low

    Allow for the possibility of relative path specification when file systems are not shared

 -- Steven Clark <smclark@ucsd.edu>  Tue, 16 May 2023 15:28:03 -0700

## hubzero-submit-distributor 3.7.0-1+deb10

=== debian/changelog ===
hubzero-submit-distributor (3.7.0-1+deb10) unstable; urgency=low

     - Changed mount point detection to recognize shared
       mount.projfs file systems. This includes /data/projects.
       This avoids extra file transfer of potentially large files.

 -- Steven Clark <smclark@ucsd.edu>  Thu, 18 May 2023 10:48:31 -0700

## hubzero-submit-distributor 3.7.1-1+deb7

=== debian/changelog ===
hubzero-submit-distributor (3.7.1-1+deb7) unstable; urgency=low

     - Update to 3.7.1

 -- Steven Clark <smclark@ucsd.edu>  Mon, 30 May 2023 07:50:53 -0700

hubzero-submit-distributor (3.7.0-1) unstable; urgency=low

     - Changed mount point detection to recognize shared
       mount.projfs file systems. This includes /data/projects.
       This avoids extra file transfer of potentially large files.

 -- Steven Clark <smclark@ucsd.edu>  Thu, 18 May 2023 10:48:31 -0700

## hubzero-submit-distributor 3.7.1-1+deb10

=== debian/changelog ===
hubzero-submit-distributor (3.7.1-1+deb10) unstable; urgency=low

     - Update to 3.7.1

 -- Steven Clark <smclark@ucsd.edu>  Mon, 30 May 2023 07:50:53 -0700

## hubzero-submit-distributor 3.7.2-1+deb7

=== debian/changelog ===
hubzero-submit-distributor (3.7.2-1+deb7) unstable; urgency=low

     - Update to version 3.7.2
    Added environment variable setting at site level
    Moved DAX3.py from distributor to common
    Add default tapissite configuration file
    streamlined download reTry, move downloadJObOutputs reeTry up one level - restart the Tapis interaction of any file download fails.
    Change for submit 3.6 data transmission including input files 

 -- Steven Clark <smclark@ucsd.edu>  Wed, 20 Dec 2023 06:57:15 -0800

hubzero-submit-distributor (3.7.1-1) unstable; urgency=low

     - Update to 3.7.1

 -- Steven Clark <smclark@ucsd.edu>  Mon, 30 May 2023 07:50:53 -0700

## hubzero-submit-distributor 3.7.2-1+deb10

=== Makefile ===
--- 
+++ 
@@ -46,7 +46,7 @@
 DISTRIBUTORSCRIPTS = update-known-hosts hubmail.py
 DISTRIBUTORMAINS = distributor.py executeRemoteBatch.py jobKill.py jobStatus.py venueProbeR.py harvester.py
 DISTRIBUTORDFTFILES = aggregators appaccess environmentwhitelist identities \
-                      managers monitors sites tools toolfiles tunnels
+                      managers monitors sites tapissites tools toolfiles tunnels
 PEGASUSTEMPLATEDIRECTORY = pegasusTemplates.d
 PEGASUSLOCALVERSIONS = 4.8.1 4.9.2 5.0.0 5.0.1
 PEGASUSLOCALCONFIGS = pegasus_local.rc sites_local.xml sites_local.yml
@@ -61,7 +61,7 @@
 	install --mode 0755 -d $(OPTSUBMIT)
 	# install-distributor-dft: 
 	for dftFile in $(DISTRIBUTORDFTFILES) ; do \
-		install --mode 0640 -D $${dftFile}.dft $(OPTSUBMIT)/$${dftFile}.dft ; \
+		install --mode 0644 -D $${dftFile}.dft $(OPTSUBMIT)/$${dftFile}.dft ; \
 	done
 	[ -f $(ETC)/submit/distributor.conf ] || \
 		install --mode 0644 -D distributor.conf_dft $(ETC)/submit/distributor.conf

=== debian/changelog ===
hubzero-submit-distributor (3.7.2-1+deb10) unstable; urgency=low

     - Update to version 3.7.2
    Added environment variable setting at site level
    Moved DAX3.py from distributor to common
    Add default tapissite configuration file
    streamlined download reTry, move downloadJObOutputs reeTry up one level - restart the Tapis interaction of any file download fails.
    Change for submit 3.6 data transmission including input files 

 -- Steven Clark <smclark@ucsd.edu>  Wed, 20 Dec 2023 06:57:15 -0800
